import { JSONString, BlockchainCommonErrors, EChain } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
export declare class BlockchainErrorMapper {
    protected static blockchainErrorMapping: Map<string, (message: string, transaction: ethers.Transaction | undefined, srcErr: unknown | null) => BlockchainCommonErrors>;
    static buildErrorFromProviderError(chain: EChain, error: Error): BlockchainCommonErrors;
    static buildBlockchainError(error: IEthersContractError): BlockchainCommonErrors;
    static buildBlockchainError<TGenericError>(error: IEthersContractError, generateGenericError?: (msg: string, err: IEthersContractError, transaction?: ethers.Transaction) => TGenericError): BlockchainCommonErrors | TGenericError;
    protected static getErrorKey(errorString: string | undefined): string;
    static getSpecificProviderError(error: any): string | null;
    private static printError;
    private static getDeepestError;
    private static getDeepestTransaction;
}
export interface IEthersContractError {
    message: string;
    code: string;
    body?: JSONString;
    error?: IEthersContractError;
    requestMethod?: string;
    url?: string;
    transaction?: ethers.Transaction;
}
//# sourceMappingURL=BlockchainErrorMapper.d.ts.map