import { BlockchainCommonErrors, FarcasterKeyRegistryContractError, FarcasterUserId, EFarcasterKeyState, ED25519PublicKey } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../../implementations/BaseContract.js";
import { IEthersContractError } from "../../implementations/BlockchainErrorMapper.js";
import { IFarcasterKeyRegistryContract } from "../../interfaces/index.js";
export declare class FarcasterKeyRegistryContract extends BaseContract<FarcasterKeyRegistryContractError> implements IFarcasterKeyRegistryContract {
    protected providerOrSigner: ethers.Provider | ethers.Signer;
    constructor(providerOrSigner: ethers.Provider | ethers.Signer);
    totalKeys(fid: FarcasterUserId, keyState: EFarcasterKeyState): ResultAsync<bigint, FarcasterKeyRegistryContractError | BlockchainCommonErrors>;
    keysOf(fid: FarcasterUserId, keyState: EFarcasterKeyState): ResultAsync<ED25519PublicKey[], FarcasterKeyRegistryContractError | BlockchainCommonErrors>;
    protected generateContractSpecificError(msg: string, e: IEthersContractError, transaction: ethers.Transaction | null): FarcasterKeyRegistryContractError;
}
//# sourceMappingURL=FarcasterKeyRegistryContract.d.ts.map